﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using C5;

namespace DarwinDotNet
{
    public abstract class Mutator : Operator
    {
        public Mutator()
            : base()
        {
        }

        public sealed override void Perform(Population population)
        {
            var prob = this.ProbabilityFunction(population);
            var chromosomes = population.Chromosomes;
            Chromosome chromosome;

            for (int i = 0; i < chromosomes.Count; i++)
            {
                chromosome = chromosomes[i];
                if (chromosome.IsOperable)
                    Perform(chromosomes[i], prob);
            }
        }

        public virtual void Perform(Chromosome chromosome, double prob)
        {
            var codons = chromosome.Codons;

            for (int i = 0; i < codons.Length; i++)
            {
                if (_rand.NextDouble() < prob)
                    codons[i] = Mutate(chromosome, i, codons[i]);
            }
        }

        public abstract object Mutate(Chromosome chromosome, int index, object codon);
    }
}
