﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace DarwinDotNet
{
    public abstract class Recombinator : PairOperator
    {
        public Recombinator()
            : base()
        {
        }

        public sealed override void Perform(Chromosome chromosomeA, Chromosome chromosomeB)
        {
            int index;
            int length;

            Recombine(chromosomeA, chromosomeB, out index, out length);
            SwapCodons(chromosomeA.Codons, chromosomeB.Codons, index, length);
        }

        public abstract void Recombine(Chromosome chromosomeA, Chromosome chromosomeB,
            out int index, out int length);

        private void SwapCodons(object[] codonsA, object[] codonsB, int index, int length)
        {
            var tempSequence = new object[length];
            Array.Copy(codonsA, index, tempSequence, 0, length);
            Array.Copy(codonsB, index, codonsA, index, length);
            Array.Copy(tempSequence, 0, codonsB, index, length);
        }
    }
}
