﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace DarwinDotNet
{
    public abstract class Selector : Operator
    {
        protected ChromosomeFitnessComparer _fitnessComparer; // Compares fitness of chromosomes.

        public Selector()
            : base(null)
        {
            _fitnessComparer = new ChromosomeFitnessComparer();
        }

        public sealed override void Perform(Population population)
        {
            SelectNextGeneration(population, population.NewChromosomes);
        }

        public abstract void SelectNextGeneration(Population population, List<Chromosome> newChromosomes);
    }

    public class ChromosomeFitnessComparer : Comparer<Chromosome>
    {
        public override int Compare(Chromosome x, Chromosome y)
        {
            return x.Fitness.CompareTo(y.Fitness);
        }
    }
}
