﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace DarwinDotNet.Selectors
{
    public class RankSelector : Selector
    {
        public RankSelector()
            : base()
        {
        }

        public override void SelectNextGeneration(Population population, List<Chromosome> newChromosomes)
        {
            var chromosomes = population.Chromosomes;
            var count = chromosomes.Count;

            chromosomes.Sort(_fitnessComparer);

            var newListCapacity = newChromosomes.Capacity;
            var firstPlusLastTerm = 1 + count;
            var totalRankSum = count * firstPlusLastTerm / 2;
            int cumulativeRank;
            Chromosome chromosome;
            while (newChromosomes.Count < newListCapacity)
            {
                cumulativeRank = _rand.Next(totalRankSum);
                chromosome = chromosomes[(2 * cumulativeRank) / firstPlusLastTerm];
                newChromosomes.Add(chromosome.Clone(false));
            }
        }
    }
}
