﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using DarwinDotNet;
using DarwinDotNet.Expressions;

namespace SymbolicRegression
{
    public static class GeneticsExtensions
    {
        public static char GetChar(this MathSymbol symbol)
        {
            switch (symbol)
            {
                case MathSymbol.Add:
                    return '+';
                case MathSymbol.Subtract:
                    return '-';
                case MathSymbol.Multiply:
                    return '*';
                case MathSymbol.Divide:
                    return '/';
                case MathSymbol.X:
                    return 'X';
                case MathSymbol.Y:
                    return 'Y';
                case MathSymbol.Z:
                    return 'Z';
                default:
                    throw new ArgumentOutOfRangeException("Unrecognised symbol.");
            }
        }
    }

    public static class MathExtensions
    {
        public static double Square(this double value)
        {
            return value * value;
        }

        public static int Square(this int value)
        {
            return value * value;
        }
    }
}
